unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label5: TLabel;
    Label_file_name: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    Label3: TLabel;
    Label_total_lines: TLabel;
    Label_number_of_columns: TLabel;
    Label74: TLabel;
    Label_N: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label_Time_all: TLabel;
    Open_file_button: TButton;
    Memo_user_data: TMemo;
    Edit_column: TEdit;
    Button_column_show: TButton;
    Edit_N: TEdit;
    Memo_Result: TMemo;
    Button_copy_result: TButton;
    Button_start_all: TButton;
    Button10: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Label2_N: TLabel;
    Label_Time: TLabel;
    Label_epoch: TLabel;
    Label_load_status: TLabel;
    Button_Step_1: TButton;
    Button_Step_3: TButton;
    Button_Step_4: TButton;
    Button_Step_6: TButton;
    Edit_epoch: TEdit;
    Button_Step_7: TButton;
    Button_Step_8: TButton;
    Button_Step_9: TButton;
    Edit_NNetEn: TEdit;
    Button8: TButton;
    Button_Step_2: TButton;
    Button_start: TButton;
    Button11: TButton;
    ProgressBar1: TProgressBar;
    Button_Step_5: TButton;
    Memo_xn: TMemo;
    Button_copy_xn: TButton;
    OpenDialog1: TOpenDialog;
    TabSheet3: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    TabSheet4: TTabSheet;
    Memo3: TMemo;
    Label6: TLabel;
    Memo4: TMemo;
    Label10: TLabel;
    Memo5: TMemo;
    Open_ALL_file_button: TButton;
    Label11: TLabel;
    Timer1: TTimer;
    Label12: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Memo6: TMemo;
    Label13: TLabel;
    procedure Open_file_buttonClick(Sender: TObject);
    procedure Button_column_showClick(Sender: TObject);
    procedure Button_copy_xnClick(Sender: TObject);
    procedure Button_Step_2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button_Step_3Click(Sender: TObject);
    procedure Button_Step_4Click(Sender: TObject);
    procedure Button_Step_5Click(Sender: TObject);
    procedure Button_Step_1Click(Sender: TObject);
    procedure Button_Step_6Click(Sender: TObject);
    procedure Button_Step_7Click(Sender: TObject);
    procedure Button_Step_8Click(Sender: TObject);
    procedure Button_Step_9Click(Sender: TObject);
    procedure Button_startClick(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button_start_allClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button_copy_resultClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Open_ALL_file_buttonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
const
N_test=10000;  //number of test sets
N_training=60000;//number of training sets
Y_max=784;   //Array Y
P_max=25;   //number of neurons in the hidden layer
N_max=9;   // the number of output neurons +1
Arr_max=(Y_max+1)*P_max;

Type
Input=array[0..Y_max] of byte;
Input2=array[0..Y_max] of real;
Output=array[0..N_max] of real;
TInputBytes = array[1..784] of Byte;
S2Ar=array[0..P_max] of real;

var
  Met:string;
  x1,x2, y1,y2:real;
  kof,b_kof:real;
  XXk:array[1..Arr_max] of real;
  Name_file:string;
  Num_files:integer;
  stop_All:boolean;
  NNetEn_100, NNetEn_400, L_inercia:real;
  ALL_Result:string;
  Form1: TForm1;
  Arr:array[1..Arr_max] of real;
  i,z,j,p,k,len,N,KX,Number,i_max:integer;
  max_lines_memo, Tab_count, Column_number, Nome, Kol_show, Tab_pos1,Tab_pos2:integer;
  Open_all, Open_all2:Tstringlist;
  S, Sn:string;
  stop, LoadFirsttime_Mnist:boolean;
  Training_data:array[1..N_training]of Input; //Array of training Data
  Training_label2:array[1..N_training] of Output;   //Array for training label
  Training_label:array[1..N_training] of byte;   //Array for training label  2
  Test_data:array[1..N_test] of Input;  //Array of test Data
  Test_label:array[1..N_test] of byte; //Array for test label
  xStream: TFileStream;
  xBuffer: Byte;
  logFile:Text;
  VM:array[1..Y_max,1..2] of integer;
  Y:Input2;  //one-dimensional array
  Sh, Sh_max, Sh_min:S2Ar;
  Sout,Err:array[0..N_max] of real;   //Sout array Err-error
  W1:array[0..Y_max,1..P_max] of real;  //W1 array
  W2, dW2:array[0..P_max,0..N_max] of real;   //W2 array
  Usred:double;
  Usre:array[1..P_max] of real;
  Norma:real;
  old_time, old_time2,old_time3,Sec1:TDateTime;
  Num_epoch, Max_epoch:integer;
  Correct_test, All_test: integer;
  Accuracy:real;
  Column:integer;
  Path, Path_2:string;
  res_int:boolean;
  SR: TSearchRec;

implementation

{$R *.dfm}
function my_str_to_float(sx:string):real;
var
RR: Extended;
res: Boolean;
begin
sx := StringReplace(sx, '.', DecimalSeparator, [rfReplaceAll]);
sx := StringReplace(sx, ',', DecimalSeparator, [rfReplaceAll]);

res:=TryStrToFloat(sx,RR);
if res then  my_str_to_float:=RR else my_str_to_float:=0;
end;

procedure TForm1.Open_file_buttonClick(Sender: TObject);
begin
max_lines_memo:=0;
Open_file_button.Enabled:=false;
OpenDialog1.Title := 'Open TXT file';
OpenDialog1.Filter:='Data(*.txt)|*.txt';
if OpenDialog1.Execute then
begin
  Memo_user_data.Clear;
  Open_all.free;
  Open_all := TStringList.Create;
  Open_all.LoadFromFile(OpenDialog1.FileName);
  Label_file_name.Caption:='file name='+OpenDialog1.FileName;
  Label11.Caption:=ExtractFileName(OpenDialog1.FileName);
  Label_total_lines.Caption:='Total lines='+inttostr(Open_all.Count);
  if  Open_all.Count>10 then max_lines_memo:=10 else max_lines_memo:=Open_all.Count;

  if  (max_lines_memo>2) then
  begin
    for i:=0 to max_lines_memo-1 do
    begin
      Memo_user_data.Lines.Add(Open_all[i]);
    end;
    S:=Open_all[0];
    p:=pos(chr(9),S);
    Tab_count:=0;
    while p>0 do
    begin
      delete(S,1,p);
      p:=pos(chr(9),S);
      p:=p;
      Tab_count:=Tab_count+1;
    end;
    if S<>'' then Column_number:=Tab_count+1 else  Column_number:=Tab_count;
    Label_number_of_columns.Caption:='Number of columns='+inttostr(Column_number);
    //Edit_N.Text:='19625';
    Edit_N.Text:=StringReplace(Memo3.Lines[4], 'N=', '', [rfReplaceAll]);
  end//if  (max_lines_memo>5) then
else Showmessage('File is not correct');
Button_column_show.Click;
end;//if OpenDialog1.Execute then



Open_file_button.Enabled:=true;
end;

procedure TForm1.Button_column_showClick(Sender: TObject);
begin
res_int:=Trystrtoint(Edit_N.Text,N);
if N>Open_all.Count then N:=Open_all.Count;
if N>19625 then N:=19625;
if N<5 then N:=5;


Edit_N.Text:=inttostr(N);
Label2_N.Caption:='N='+inttostr(N);
Application.ProcessMessages;
if max_lines_memo<5 then exit;
Button_column_show.Enabled:=false;
Memo_xn.Clear;
Open_all2 := TStringList.Create;
res_int:=Trystrtoint(Edit_column.Text,Nome);
if  Nome>Column_number then
begin
  Nome:=Column_number;
  Edit_column.Text:=inttostr(Nome);
end;
if  Nome<1 then
begin
  Nome:=1;
  Edit_column.Text:=inttostr(Nome);
end;
Application.ProcessMessages;
if Open_all.Count>N then Kol_show:=N  else Kol_show:=Open_all.Count;
for i:=1 to Arr_max do Arr[i]:=0; //zerroing

for i:=0 to Kol_show-1 do
begin
  S:=Open_all[i];Sn:='0';
  len:=length(S);
  if len>0 then
  begin
  Tab_count:=0; k:=0; Tab_pos1:=0;  Tab_pos2:=0;
  repeat
  k:=k+1;
  if S[k]=chr(9) then
  begin
    Tab_count:=Tab_count+1;
    if Tab_count=Nome then Tab_pos2:=k;
    if Tab_count=(Nome-1) then Tab_pos1:=k;
  end;
  until (k=len) or (Tab_pos2<>0);
if Tab_pos2=0 then  Tab_pos2:=len+1;
Sn:=Copy(S,Tab_pos1+1,(Tab_pos2-Tab_pos1-1));
  end;
Arr[i+1]:=my_str_to_float(Sn);
if i<30 then Open_all2.Add(inttostr(i+1)+chr(9)+floattostr(Arr[i+1]));

end;
Memo_xn.Lines:=Open_all2;
Open_all2.Free;
Button_column_show.Enabled:=true;
end;

procedure TForm1.Button_copy_xnClick(Sender: TObject);
begin
Button_copy_xn.Enabled:=false;
Memo_xn.SelectAll;
Memo_xn.CopyToClipboard;
Button_copy_xn.Enabled:=true;
end;

procedure TForm1.Button_Step_2Click(Sender: TObject);
var
Buffer : TInputBytes;
begin
if LoadFirsttime_Mnist then
begin
  Button_Step_2.Enabled:=false;
  sleep(500);
  ///////////Zeroing start
  for j:=1 to N_training do
  begin
    Training_data[j][0]:=1; //Bias
    for i:=1 to  Y_max do  Training_data[j][i]:=0;
  end;

  for j:=1 to N_training do
  for i:=0 to N_max do Training_label2[j,i]:=0;
  for j:=1 to N_training do Training_label[j]:=0;
  for j:=1 to N_test do
  begin
    Test_data[j][0]:=1; //Bias
    for i:=1 to  Y_max do  Test_data[j][i]:=0;
  end;
  for j:=1 to N_test do Test_label[j]:=0;
  ///////////Zeroing finish

  //Loading training data
   Path_2:='';
  if  Memo3.Lines[5]='Path=' then  Path_2:=Path+'MNIST_10\'
  else
  begin
  Path_2:=Memo3.Lines[5];
  Path_2:=StringReplace(Path_2, 'Path=', '', [rfReplaceAll]);
  end;


  xStream:=TFileStream.Create(Path_2+'train-images.idx3-ubyte',fmOpenRead or fmShareDenyWrite);
  for k:=1 to N_training do
  begin
    xStream.Position:=16+(k-1)*784;
    xStream.ReadBuffer(Buffer,784);
    for i:=1 to 28 do
    for j:=1 to 28 do Training_data[k][(j-1)*28+i]:=Buffer[(i-1)*28+j];

    if (k mod 1000) =0  then begin Label_load_status.Caption:='Training Data';
                                    ProgressBar1.Position:=round(100*(k/N_training));
                                    Application.ProcessMessages;
                                    end;

  end;

  xStream.Free;
  xStream:=TFileStream.Create(Path_2+'train-labels.idx1-ubyte',fmOpenRead or fmShareDenyWrite);
  for k:=1 to N_training do
  begin
    xStream.Position:=8+(k-1);
    xStream.ReadBuffer(xBuffer,1);
    Training_label2[k][xBuffer]:=1; //Array for training label
    Training_label[k]:=xBuffer; //Array for training label  2
    if (k mod 1000) =0  then begin Label_load_status.Caption:='Training Label';
                                    ProgressBar1.Position:=round(100*(k/N_training));
                                    Application.ProcessMessages;
                                    end;
  end;
  xStream.Free;
  //Loading test data
  xStream:=TFileStream.Create(Path_2+'t10k-images.idx3-ubyte',fmOpenRead or fmShareDenyWrite);
  Label_load_status.Caption:='Test Data';
  Application.ProcessMessages;
  for k:=1 to N_test do
  begin
    xStream.Position:=16+(k-1)*784;
    xStream.ReadBuffer(Buffer,784);
    for i:=1 to 28 do
    for j:=1 to 28 do Test_data[k][(j-1)*28+i]:=Buffer[(i-1)*28+j];
  end;

  xStream.Free;
  xStream:=TFileStream.Create(Path_2+'t10k-labels.idx1-ubyte',fmOpenRead or fmShareDenyWrite);
  Label_load_status.Caption:='Test Label';
  Application.ProcessMessages;
  for k:=1 to N_test do
  begin
    xStream.Position:=8+(k-1);
    xStream.ReadBuffer(xBuffer,1);
    Test_label[k]:=xBuffer;
  end;
  xStream.Free;

  //// Load T_pattern
  Label_load_status.Caption:='Load T_pattern';
  Application.ProcessMessages;
  AssignFile(logFile, Path+'T_pattern\T-pattern-3.VM');
  if  FileExists(Path+'T_pattern\T-pattern-3.VM') then
  begin
   Reset(logFile);
   Readln(logFile,KX);
   for i:=1 to KX do Readln(logFile,VM[i][1],VM[i][2]);
   CloseFile(logFile);
  end
    else Showmessage('No File '+'T_pattern\T-pattern-3.VM');

  Button_Step_2.Enabled:=true;
  LoadFirsttime_Mnist:=false;
end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
LoadFirsttime_Mnist:=true;
Sec1:=StrToTime('15:03:45')-StrToTime('15:03:44');
Path:=extractfilepath(paramstr(0));
Memo3.Clear;
Memo4.Clear;
Memo3.Lines.LoadFromFile(Path+'\init.txt');
if Memo3.Lines[3]='METHOD=1' then RadioButton1.Checked:=true;
if Memo3.Lines[3]='METHOD=2' then RadioButton2.Checked:=true;
if Memo3.Lines[3]='METHOD=3' then RadioButton3.Checked:=true;
if Memo3.Lines[3]='METHOD=4' then RadioButton4.Checked:=true;
if Memo3.Lines[3]='METHOD=5' then RadioButton5.Checked:=true;
if Memo3.Lines[3]='METHOD=6' then RadioButton6.Checked:=true;
Edit_N.Text:=StringReplace(Memo3.Lines[4], 'N=', '', [rfReplaceAll]);
Memo5.Clear;
 if FindFirst(Path+'\DATA\'+'*.txt',faAnyFile,SR) = 0 then
  repeat
    Memo5.Lines.Add(SR.Name)
  until (FindNext(SR) <> 0);
  FindClose(SR);

if Memo3.Lines[2]='AUTO=YES' then
begin
Label12.Caption:='AUTO';
Label12.Font.Color:=clRed;
Timer1.Enabled:=true;
end
else Label12.Caption:='';

end;

procedure TForm1.Button_Step_3Click(Sender: TObject);
begin
Button_Step_3.Enabled:=false;
sleep(500);
for i:=0 to  Y_max do Y[i]:=0;
for i:=0 to  P_max do Sh[i]:=0;
for i:=0 to  N_max do begin Sout[i]:=0; Err[i]:=0; end;

for i:=0 to  Y_max do
for j:=1 to  P_max do W1[i,j]:=0;
for i:=0 to  P_max do
for j:=0 to  N_max do   begin W2[i,j]:=0;  dW2[i,j]:=0;end;

//The initial values of the weights W2 are set 0.5.
for i:=0 to P_max do
for j:=0 to N_max do  W2[i,j]:=0.5;

Button_Step_3.Enabled:=true;


end;

procedure TForm1.Button_Step_4Click(Sender: TObject);
begin
Button_Step_4.Enabled:=false;
sleep(500);
if RadioButton1.Checked then
begin
///  doubling
k:=0;
for j:=1 to P_max do
begin
i:=-1;
repeat
i:=i+1;
k:=k+1;
if k<=N then W1[i,j]:= Arr[k]
else
begin
k:=0;  i:=i-1;
end;

until i=Y_max;

end;

end; //if RadioButton1.Checked then


if RadioButton2.Checked then
begin
///  c 
k:=0;
for j:=1 to P_max do
begin
i:=-1;
repeat
i:=i+1;
k:=k+1;
if k<=N then W1[i,j]:= Arr[k]
else
begin
k:=0; i:=Y_max;
end;

until i=Y_max;
  if k=N then k:=0;
end;

end;//  if RadioButton2.Checked then

if RadioButton3.Checked then
begin
///  

for i:=1 to N do
begin
XXk[i]:=(((i-1)/(N-1))*(19625-1))+1;
end;

k:=0;
for j:=1 to P_max do
for i:=0 to Y_max do
begin
k:=k+1;
z:=0;
repeat
z:=z+1;
until (z=N) or (XXk[z]>=k);
z:=z;
if z=1 then z:=z+1;

x1:=XXk[z-1];
x2:=XXk[z];
y1:=Arr[z-1];
y2:=Arr[z];
if x1=x2 then kof:=0 else kof:=(y1-y2)/(x1-x2);

b_kof:=y1-kof*x1;
W1[i,j]:=kof*k+b_kof;
end;

end; //  if RadioButton3.Checked then


if RadioButton4.Checked then
begin
///  doubling
k:=0;
for i:=0 to Y_max do
begin
j:=0;
repeat
j:=j+1;
k:=k+1;
if k<=N then W1[i,j]:= Arr[k]
else
begin
k:=0;  j:=j-1;
end;

until j=P_max;

end;

end; //if RadioButton4.Checked then

if RadioButton5.Checked then
begin
///W1 matrix filling  Method 5
k:=0;
for i:=0 to Y_max do
begin
j:=0;
repeat
j:=j+1;
k:=k+1;
if k<=N then W1[i,j]:= Arr[k]
  else
  begin
    k:=0; j:=P_max;
  end;
until j=P_max;
if k=N then k:=0;
end;

end; //if RadioButton5.Checked then

if RadioButton6.Checked then
begin
///  

for i:=1 to N do
begin
XXk[i]:=(((i-1)/(N-1))*(19625-1))+1;
end;

k:=0;
for i:=0 to Y_max do
for j:=1 to P_max do
begin
k:=k+1;
z:=0;
repeat
z:=z+1;
until (z=N) or (XXk[z]>=k);
z:=z;
if z=1 then z:=z+1;

x1:=XXk[z-1];
x2:=XXk[z];
y1:=Arr[z-1];
y2:=Arr[z];
if x1=x2 then kof:=0 else kof:=(y1-y2)/(x1-x2);

b_kof:=y1-kof*x1;
W1[i,j]:=kof*k+b_kof;
end;

end; //  if RadioButton6.Checked then

Button_Step_4.Enabled:=true;
end;

Function VM_transform(XXX:Input):Input;  //T_Pattern transformation
var
tt:integer;
begin
for tt:=1 to  Y_max do
begin
  VM_transform[tt]:=XXX[(VM[tt][2]-1)*28+VM[tt][1]];
end;
VM_transform[0]:=1;
end;

function Normalization(XX:Input):Input2;
var t1:integer;
    d1,d2:integer;
begin
Normalization[0]:=1; // Bias
for t1:=1 to Y_max do  Normalization[t1]:=XX[t1]/255;
end;


procedure TForm1.Button_Step_5Click(Sender: TObject);
var
pp:integer;
begin
Button_Step_5.Enabled:=false;
sleep(500);
for j:=0 to P_max do Sh_max[j]:=0;
for j:=0 to P_max do Sh_min[j]:=100;

for  Number:=1 to N_training do
begin
  Y:=Normalization(VM_transform(Training_data[Number]));
  Sh[0]:=1;
  Sh_max[0]:=1; Sh_min[0]:=1;  //Not used
  for j:=1 to P_max do
  begin
    Sh[j]:=0;
    for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];

    if Sh[j]>Sh_max[j] then Sh_max[j]:=Sh[j];  //Find maximum Sh
    if Sh[j]<Sh_min[j] then Sh_min[j]:=Sh[j];  //Find minimum Sh

  end; //  for j:=1 to P_max do
end;

////
for pp:=1 to P_max do
begin
  j:=pp;
  Number:=0;
  Usred:=0;
  repeat
    Number:=Number+1;
    Y:=Normalization(VM_transform(Training_data[Number]));
    Sh[j]:=0;
    for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];
    if (Sh_max[j]-Sh_min[j])<>0 then Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5);

    Usred:=Usred+ Sh[j];
  until  (Number=1000);
  Usred:=Usred/Number;
  Usre[pp]:=Usred;
end;

Button_Step_5.Enabled:=true;
end;


procedure TForm1.Button_Step_1Click(Sender: TObject);
begin
if max_lines_memo<5 then
begin
ShowMessage('Please load data!');
exit;
end;

Button_Step_1.Enabled:=false;
Button_column_show.Click;
sleep(500);
Button_Step_1.Enabled:=true;
end;

procedure TForm1.Button_Step_6Click(Sender: TObject);
begin
Button_Step_6.Enabled:=false;
sleep(500);
res_int:=Trystrtoint(Edit_epoch.Text,Max_epoch);
if Max_epoch<1 then Max_epoch:=1;
Edit_epoch.Text:=inttostr(Max_epoch);
Application.ProcessMessages;
Button_Step_6.Enabled:=true;
end;

function Fout(R:real):real;   // Fout is logistic activation function
begin
Fout:=1/(1+exp(-R));
end;

procedure TForm1.Button_Step_7Click(Sender: TObject);
begin
Button_Step_7.Enabled:=false;
sleep(500);
Norma:=0.2;// learning rate
old_time:=now;
Num_epoch:=0;

repeat
Num_epoch:=Num_epoch+1;

  Label_epoch.Caption:='Current epoch ='+inttostr(Num_epoch);
  Application.ProcessMessages;
  Number:=0;
  repeat
  Number:=Number+1;
    if (now-old_time)>Sec1 then
      begin
        Label_Time.Caption:='Time passed [s]='+inttostr(round((now-old_time2)/Sec1));
        Application.ProcessMessages; old_time:=now;
      end;

    Y:=Normalization(VM_transform(Training_data[Number]));

    for j:=1 to P_max do   // matrix multiplication Sh=fh(Y*W1)
    begin
      Sh[j]:=0;
      for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];
      if (Sh_max[j]-Sh_min[j])<>0 then Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5)-Usre[j];
    end;

  Sh[0]:=1;  //bias

  for j:=0 to N_max do
  begin
    Sout[j]:=0;
    for i:=0 to P_max do Sout[j]:=Sout[j]+Sh[i]*W2[i,j];
    Sout[j]:=Fout(Sout[j]);
  end;

  //Errors of back-propagation method
  for i:=0 to N_max do Err[i]:=(Training_label2[Number][i]-Sout[i])*Sout[i]*(1-Sout[i]);
  //back-propagation method
  for i:=0 to P_max do
  for j:=0 to N_max do
  begin
    dW2[i,j]:=Norma*Err[j]*Sh[i];
    W2[i,j]:=W2[i,j]+dW2[i,j];
  end;

  until (Number=N_training)or(stop);

until (Num_epoch=Max_epoch)or(stop);

Button_Step_7.Enabled:=true;

end;

procedure TForm1.Button_Step_8Click(Sender: TObject);
begin

Button_Step_8.Enabled:=false;
sleep(500);

Correct_test:=0; All_test:=0;
for Number:=1 to N_test do
begin
  Y:=Normalization(VM_transform(Test_data[Number]));
  for j:=1 to P_max do
  begin
    Sh[j]:=0;
    for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];
    if (Sh_max[j]-Sh_min[j])<>0 then Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5)-Usre[j]; // fh is identity activation function,
  end;
  Sh[0]:=1;

  for j:=0 to N_max do
  begin
    Sout[j]:=0;
    for i:=0 to P_max do Sout[j]:=Sout[j]+Sh[i]*W2[i,j];
    Sout[j]:=Fout(Sout[j]);
  end;
  i_max:=1; All_test:=All_test+1;
  For i:=0 to N_max do if Sout[i]>Sout[i_max] then i_max:=i;
  //  counting the right tests
  if i_max=Test_label[Number] then Correct_test:=Correct_test+1;
end;

//classification accuracy
Accuracy:=(Correct_test/All_test)*100;


Button_Step_8.Enabled:=true;

end;

procedure TForm1.Button_Step_9Click(Sender: TObject);
begin
Button_Step_9.Enabled:=false;
sleep(500);
if not stop then Edit_NNetEn.Text:=floattostrf(Accuracy/100,fffixed,4,4);
Button_Step_9.Enabled:=true;
end;

procedure TForm1.Button_startClick(Sender: TObject);
begin
if max_lines_memo<5 then
begin
ShowMessage('Please load data!');
exit;
end;

Button_start.Enabled:=false;
old_time2:=now;
Label_Time.Caption:='Time passed [s]='+inttostr(round((now-old_time2)/Sec1));
Application.ProcessMessages;
stop:=false;
Edit_NNetEn.Text:='';
Button_Step_1.Click;
Button_Step_2.Click;
Button_Step_3.Click;
Button_Step_4.Click;
Button_Step_5.Click;
Button_Step_6.Click;
Button_Step_7.Click;
Button_Step_8.Click;
Button_Step_9.Click;

if not stop then Memo_Result.Lines.Add(Edit_column.Text+chr(9)+Edit_NNetEn.Text+chr(9)+Edit_epoch.Text+chr(9)+Edit_N.Text+chr(9)+Label_file_name.Caption);

Label_Time.Caption:='Time passed [s]='+inttostr(round((now-old_time2)/Sec1));
Application.ProcessMessages;

Button_start.Enabled:=true;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
stop:=true;
stop_All:=true;
end;

procedure TForm1.Button_start_allClick(Sender: TObject);
var
imgWindow: TBitmap;
begin

if  max_lines_memo<2 then Open_file_button.Click;
if max_lines_memo<2 then begin Showmessage('File not correct'); exit; end;
stop:=false;
Button_start_all.Enabled:=false;

old_time3:=now;
Label_Time_all.Caption:='Time passed [s]='+inttostr(round((now-old_time3)/Sec1));
Application.ProcessMessages;

Column:=0;
repeat
 Column:=Column+1;
 Edit_column.Text:=inttostr(Column);
 Application.ProcessMessages;
 //Button_column_show.Click;
 Edit_epoch.Text:=Memo3.Lines[0];
 Application.ProcessMessages;
 ALL_Result:='';
 Button_start.Click;
 Application.ProcessMessages;
 ALL_Result:=ALL_Result+Edit_NNetEn.Text+' ';
 NNetEn_100:=strtofloat(Edit_NNetEn.Text);
 sleep(2000);
 Edit_epoch.Text:=Memo3.Lines[1];
 Application.ProcessMessages;
 Button_start.Click;
 Application.ProcessMessages;
 ALL_Result:=ALL_Result+Edit_NNetEn.Text+' ';
 NNetEn_400:=strtofloat(Edit_NNetEn.Text);
 sleep(2000);
 L_Inercia:=(NNetEn_400-NNetEn_100)/NNetEn_400;
 ALL_Result:=ALL_Result+' '+FloatToStrF(L_Inercia, ffFixed, 4, 4);
 ALL_Result := StringReplace(ALL_Result, '.', ',', [rfReplaceAll]);

 Memo4.Lines.Add(ALL_Result);
 Label_Time_all.Caption:='Time passed [s]='+inttostr(round((now-old_time3)/Sec1));
 Application.ProcessMessages;
until  (Column=Column_number) or stop;

if RAdiobutton1.Checked then Met:='M1_';
if RAdiobutton2.Checked then Met:='M2_';
if RAdiobutton3.Checked then Met:='M3_';
if RAdiobutton4.Checked then Met:='M4_';
if RAdiobutton5.Checked then Met:='M5_';
if RAdiobutton6.Checked then Met:='M6_';

 Memo_Result.Lines.SaveToFile(Path+'Results\last_result_'+FormatDateTime('mm-dd-yyyy-hhnnss',now())+'.txt');
 //S:=Path+'DATA_RESULT\'+Label11.Caption+'_result_'+Met+FormatDateTime('mm-dd-yyyy-hhnnss',now());
  S:=Path+'DATA_RESULT\'+Label11.Caption+'_Result';
  S := StringReplace(S, '.txt', '', [rfReplaceAll]);
 Memo4.Lines.SaveToFile(S+'.txt');

{ imgWindow := TBitmap.Create;
   try
     imgWindow := Form1.GetFormImage;
     imgWindow.SaveToFile(Path+'Results\Form_Image.bmp');
   finally
     imgWindow.Free;
   end;             }

 Button_start_all.Enabled:=true;
 stop:=false;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
stop:=true;
stop_All:=true;
end;

procedure TForm1.Button_copy_resultClick(Sender: TObject);
begin
Button_copy_result.Enabled:=false;
Memo_Result.SelectAll;
Memo_Result.CopyToClipboard;
Button_copy_result.Enabled:=true;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
Edit_NNetEn.SelectAll;
Edit_NNetEn.CopyToClipboard;
end;

procedure TForm1.Open_ALL_file_buttonClick(Sender: TObject);
begin
stop_All:=false;
Open_ALL_file_button.Enabled:=false;
Num_files:=0;
if Memo5.Lines.Count>0 then
begin
repeat
  Memo4.Clear;
  Memo_Result.Clear;
  Num_files:=Num_files+1;
  max_lines_memo:=0;
  Memo_user_data.Clear;
  Open_all.free;
  Open_all := TStringList.Create;
  Name_file:=Path+'DATA\'+Memo5.Lines[Num_files-1];
  Open_all.LoadFromFile(Name_file);
  Label_file_name.Caption:='file name='+Name_file;
  Label11.Caption:=Memo5.Lines[Num_files-1];
  Label_total_lines.Caption:='Total lines='+inttostr(Open_all.Count);
  if  Open_all.Count>10 then max_lines_memo:=10 else max_lines_memo:=Open_all.Count;

  if  (max_lines_memo>2) then
  begin
    for i:=0 to max_lines_memo-1 do
    begin
      Memo_user_data.Lines.Add(Open_all[i]);
    end;
    S:=Open_all[0];
    p:=pos(chr(9),S);
    Tab_count:=0;
    while p>0 do
    begin
      delete(S,1,p);
      p:=pos(chr(9),S);
      p:=p;
      Tab_count:=Tab_count+1;
    end;
    if S<>'' then Column_number:=Tab_count+1 else  Column_number:=Tab_count;
    Label_number_of_columns.Caption:='Number of columns='+inttostr(Column_number);
   // Edit_N.Text:='19625';
   Edit_N.Text:=StringReplace(Memo3.Lines[4], 'N=', '', [rfReplaceAll]);
  end//if  (max_lines_memo>5) then
else
begin
if Open_all[0]='TURBO' then
begin
  S:=Path+'DATA_RESULT\'+Label11.Caption+'_Result';
  S := StringReplace(S, '.txt', '', [rfReplaceAll]);
 Memo6.Lines.SaveToFile(S+'.txt');
end
else Showmessage('File is not correct');
end;
if not (Open_all[0]='TURBO') then
begin
Button_column_show.Click;
Button_start_all.Click;
end;
until stop_All or (Num_files=Memo5.Lines.Count);
Form1.close;
end;//if Memo5.Lines.Count>1 then



Open_ALL_file_button.Enabled:=true;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=false;
Open_ALL_file_button.Click;

end;

end.
